/* $Id: bstream.h,v 1.2 2002/06/14 13:54:04 aa5779 Exp $ */
#ifndef BSTREAM_H
#define BSTREAM_H

#include "interp.h"
#include "util.h"

typedef struct basic_stream
{
	int size;
	flow_class *fc;
	flow_handle_t fh;
	int cooked_mode;
} basic_stream;

stream *create_basic(char *name, char *fname, int datasize, int writeable);
stream *bs_open(interpreter *i, char *name, char *fname, int writeable);
void bs_close(interpreter *i, stream *s);
html_chunk *bs_read(interpreter *i, stream *s);
void bs_writestr(interpreter *i, stream *s, char *str);
void bs_writetag(interpreter *i, stream *s, html_chunk *ch);
char *bs_ioctl(interpreter *i, stream *s, char *ctlstr);
int bs_getpos(interpreter *i, stream *s);
void bs_setpos(interpreter *i, stream *s, int pos);
void bs_rewind(interpreter *i, stream *s);

#ifndef BSTREAM_IMP
extern stream_class basic_stream_class;
#endif

stream *dummy_open(interpreter *i, char *name, char *fname, int writeable);
void dummy_close(interpreter *i, stream *s);
html_chunk *dummy_read(interpreter *i, stream *s);
void dummy_writestr(interpreter *i, stream *s, char *str);
void dummy_writetag(interpreter *i, stream *s, html_chunk *ch);
char *dummy_ioctl(interpreter *i, stream *s, char *ctlstr);
int dummy_getpos(interpreter *i, stream *s);
void dummy_setpos(interpreter *i, stream *s, int pos);
void dummy_rewind(interpreter *i, stream *s);



#endif

