/*$Id: crypt.c,v 1.8 2002/06/14 13:54:04 aa5779 Exp $*/
/*
	Copyright (C) 2001 Artem V. Andreev (artem@AA5779.spb.edu)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <modules.h>
#include <util.h>
#include <dstring.h>
#ifdef HAVE_CRYPT_H
#include <crypt.h>
#endif
#include "version.h"
/// \section[NAME]
// \em[crypt] -- a module for NSL (see \ref[sl(1)])

/// \section[OVERVIEW]
// this module provides binding to POSIX crypt function.
// It add the only builtin: \em[crypt(key salt)]
// For details see \ref[crypt(3)]

static module *this_mod;
extern procstack *get_pstack(void);

void crypt_LTX_init(module *this)
{
	this_mod = this;
}

static void bi_crypt(chunk *current, interpreter *i, value *args)
{
	char *crypted = crypt(DS_BODY(args->val), DS_BODY(next_value(args)->val));
	ds_appendstr(get_pstack()->state->buffer, crypted);
}

static master_instruction_src crypt_src_add[] = {
										{"crypt", 1, bi_crypt, 2, 2, 2}, 
										{NULL}
										};

void crypt_LTX_attach(mod_attach *ma)
{
	append_builtins(ma->i, crypt_src_add);
}

const char crypt_LTX_version[] = VERSION;
const char crypt_LTX_date[] = __DATE__;
/// \section[AUTHOR]
// Artem V. Andreev

/// \section[COPYRIGHT]
// see \ref[sl(1)]

/// \seealso
